    program

    map
      main()
    end

   include('cwsynchm.inc'),once
   include('abwindow.inc'),once

semaphoreName    equate('demoSemaphore')

iSema            &ISemaphore
maxCount         equate(3)
initCount        equate(3)

  code


  main()

  return

main procedure()

Window WINDOW('Caption'),AT(,,235,138),FONT('MS Sans Serif',8,,FONT:regular),GRAY
       BUTTON('&Cancel'),AT(89,100,39,14),USE(?CancelButton),LEFT
     END

thisWindow    class(windowManager)
releaseSemaphore bool
init             procedure(),byte,proc,virtual
kill             procedure(),byte,proc,virtual
takeAccepted     procedure(),byte,proc,virtual
           end
  code


  thisWindow.run()

  return

thisWindow.init procedure()

err   long,auto

  code

  ! create a semaphore and use the initial and max count options
  ! set the initial count to three, as an app starts the wait function is called.
  ! the count will decreased by one each time wait is called.
  ! when the count is greater than zero then the semaphore is in the signaled state and will return wait ok from the wait call
  iSema &= NewNamedSemaphore(semaphoreName, initCount, maxCount)

  ! cal try wait and get the result, this does not block but still decrements the count of the semaphore
  err = iSema.trywait(0)

  ! if time out then not signaled so kill it, this will decrease the semaphore count by one
  if err = WAIT:TIMEOUT
    message('Three apps running,  this one will not start')
    ! set the flag to not release, or the count will be off
    self.releaseSemaphore = false
    return level:notify
  elsif err = WAIT:OK
    ! in the signaled (count is greater than 0) state so app can continue
    ! set the flag to release so the count is increased
    self.releaseSemaphore = true
  end

  parent.init()
  self.open(window)

  return 0

thisWindow.kill procedure()

  code

  if (self.releaseSemaphore = true)
    ! release so the count goes up
    iSema.Release(1)
  end

  ! this does not decrement the counter
  iSema.kill()

  parent.kill()

  return 0
  
thisWindow.TakeAccepted procedure()

  code

  parent.TakeAccepted()
  case accepted()
  of ?CancelButton
    post(event:closeWindow)
  end

  return 0





